﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Praktikum_2
{
    class Gebäude
    {
        Raum[] räume;

        public Gebäude(Raum[] räume)
        {
            this.räume = räume;
        }

        public string BerichteÜberWärmeflüsse()
        {
            for (int i = 0; i < räume.Length; i++)
            {
                räume[i].BestimmeWärmezufluss();
            }

            string s = ""; // besser mit StringBuilder
            for (int i = 0; i < räume.Length; i++)
            {
                double zufluss = räume[i].Wärmezufluss;
                s += räume[i].Name + ((zufluss >= 0.0) ? " gewinnt " : " verliert ")
                    + Math.Abs(zufluss) + " Watt.\n";
            }
            return s;
        }
    }

    class Raum
    {
        string name;
        public string Name { get { return name; } }
        double temperatur;
        public double Temperatur { get { return temperatur; } }
        double wärmezufluss;
        public double Wärmezufluss { get { return wärmezufluss; } }
        Wand[] wände;

        public Raum(string name, Wand[] wände, double temperatur)
        {
            this.name = name;
            this.temperatur = temperatur;
            this.wände = wände;
            for (int i = 0; i < wände.Length; i++)
            {
                wände[i].MerkeRaum(this);
            }
        }

        public virtual void BestimmeWärmezufluss()
        {
            wärmezufluss = 0.0;
            for (int i = 0; i < wände.Length; i++)
            {
                wärmezufluss += wände[i].BestimmeWärmezufluss(this);
            }
        }
    }

    class Wand // sollte später abstract sein
    {
        double breite;
        double höhe;
        protected double wärmedurchgangskoeffizient;
        Raum raum1, raum2;

        public Wand(double breite, double höhe)
        {
            this.breite = breite;
            this.höhe = höhe;
        }

        public double BestimmeWärmezufluss(Raum dieserRaum)
        {
            Raum andererRaum = raum2;
            if(dieserRaum == raum2)
            {
                andererRaum = raum1;
            }

            return wärmedurchgangskoeffizient * breite * höhe
                * (andererRaum.Temperatur - dieserRaum.Temperatur);
        }

        public void MerkeRaum(Raum r)
        {
            if(raum1 == null)
            {
                raum1 = r;
            }
            else
            {
                raum2 = r;
            }
        }
    }

    class Innenwand : Wand
    {
        public Innenwand(double breite, double höhe)
            : base(breite, höhe)
        {
            this.wärmedurchgangskoeffizient = 1.0;
        }
    }

    class Außenwand : Wand
    {
        public Außenwand(double breite, double höhe)
            : base(breite, höhe)
        {
            this.wärmedurchgangskoeffizient = 0.3;
        }
    }
}